#include<stdio.h>
#include<stdlib.h>
#include"string.h"
#include<menuet/os.h>
#include<mgtk/app.h>

void MGTK_Init(void);

extern "C" char * strdup(char *);

static char * std_app_title="MGTK Application";

static inline void read_mouse(int * x,int * y,int * b)
{
 int v;
 __asm__ __volatile__("int $0x40":"=a"(v):"0"(37),"b"(1));
 *y=(v&0xffff);
 *x=v>>16;
 if((*x)<0 || (*x)>10000) (*x)=0;
 if((*y)<0 || (*y)>10000) (*y)=0;
 __asm__ __volatile__("int $0x40":"=a"(v):"0"(37),"b"(2));
 *b=v;
}

GApplication::GApplication(GRect * r):GGroup()
{
 MGTK_Init();
 Flags=wf_Visible;
 Caption=std_app_title;
 Size.x=r->w;
 Size.y=r->h;
 Origin.x=6;
 Origin.y=25;
 priv_origin.x=r->x; 
 priv_origin.y=r->y; 
 priv_size.x=r->w+12;
 priv_size.y=r->h+30;
}

GApplication::~GApplication()
{
 this->GGroup::~GGroup();
}

void GApplication::SetCaption(char * cap)
{
 if(Caption==std_app_title) return;
 free(Caption);
 if(!cap)
 {
  Caption=std_app_title;
  return;
 }
 Caption=strdup(cap);
}

void GApplication::Init(void)
{
 body=0x03000000|RGB(236,233,216);
 grab=0x00000080;
 frame=RGB(95,85,0);
 __menuet__set_bitfield_for_wanted_events(7|EVENT_MOUSE_CHANGE);
}

void GApplication::Run(void)
{
 int i;
 GEvent ev;
 GPoint m,n;
 int b;
 m.x=0;
 m.y=0;
 n.x=0;
 n.y=0;
 b=0;
 __menuet__window_redraw(1);
 DrawWidget();
 __menuet__window_redraw(2);
 for(;;)
 {
  ClearEvent(&ev);
  if(!WFirst)
   i=__menuet__wait_for_event();
  else {
   __menuet__delay100(3);
   i=__menuet__check_for_event();
  }
  ev.evType=GEVENT_COMMAND;
  switch(i)
  {
   case 0:
    ev.evType=GEVENT_IDLE;
    break;
   case 1:
    __menuet__window_redraw(1);
    DrawWidget();
    __menuet__window_redraw(2);
    continue;
   case 2:
    ev.evType=GEVENT_KEYBOARD;
    ev.type.key.keyId=__menuet__getkey();
    break;
   case 3:
    ev.evType=GEVENT_BUTTON;
    ev.type.button.butId=__menuet__get_button_id();
    if(ev.type.button.butId==1)
    {
     ev.evType=GEVENT_COMMAND;
     ev.type.command.evCommand=cm_Quit;
     HandleEvent(&ev);
     return;
    }
    break;
   case 6:
    read_mouse(&n.x,&n.y,&b);
    ev.type.mouse.bMouse=b;
    ev.type.mouse.xMouse=m.x;
    ev.type.mouse.yMouse=m.y;
    if(b!=0)
    {
     ev.evType=GEVENT_CLICK;
    } else if(m.x!=n.x || m.y!=n.y)
    {
     m.x=n.x;
     m.y=n.y;
     ev.evType=GEVENT_MOUSE;
    }
    break;
   default:
    continue;
  }
  HandleEvent(&ev);
 }
}

void GApplication::Done(void)
{
}

void GApplication::DrawWidget(void)
{
 __menuet__define_window(priv_origin.x,priv_origin.y,
                         priv_size.x,priv_size.y,
			 body,grab,frame);
 __menuet__write_text(7,6,0x10ffffff,Caption,strlen(Caption));
 this->GGroup::DrawWidget();
 __menuet__delay100(3);
}
